/*
 *  Copyright (C) 2014-2015 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014-2015 by FUJI SOFT INCORPORATED, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *  
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: OperationManager.c 122 2015-07-17 01:31:28Z ertl-honda $
 */  

/*
 *		CDD SW-C OperationManagerѤε
 */

#include "Rte_OperationManager.h"
#include "ModelCarControl.h"
#include "rcb3.h"
#include "t_syslog.h"


/* ܥǥϾ(20ms * 6 = 120ms) */
#define BODY_SEND_COUNT			6U

/*
 *  OperationControlʥ֥
 */
void
OperationControl(void)
{
	Std_ReturnType		ercd;
	IDT_RCB3			rcb3_bstate;

	IDT_Angle	angle;
	IDT_Speed	speed;
	IDT_Adjust	steern;
	IDT_Adjust	gain;
	IDT_Brake	brake = FALSE;
	IDT_Lamp	headlamp = FALSE;
	IDT_Lamp	foglamp = FALSE;
	IDT_Lamp	hazard = FALSE;
	IDT_Lamp	winker_r = FALSE;
	IDT_Lamp	winker_l = FALSE;


#ifdef TOPPERS_WITH_DISP
	IDT_Disp	disp;
	IDT_Cycle	cycle;
	IDT_Switch	differ = FALSE;
	IDT_Switch	swich_angle = FALSE;
	IDT_Switch	swich_speed = FALSE;
	IDT_Switch	pwm_angle = FALSE;
	IDT_Switch	pwm_speed = FALSE;
#endif /* TOPPERS_WITH_DISP */

	/* RCB3ȥ餫褿RCB3ޥɤμ */
	ercd = Rte_Call_RCB3CommandClt_OpGetIfRCB3Command(&rcb3_bstate);
	if (ercd != RTE_E_OK) {
		syslog(LOG_INFO, "## Error: Rte_Call_RCB3CommandClt_OpGetIfRCB3Command()");
	}
	else if (rcb3_bstate != NOT_RECEIVE_COMMAND) {
		/* ON/OFFڤؤ */
		if ((rcb3_bstate & RCB3_MSG_BUTTON_NOUGHT) != 0U) {
			headlamp = TRUE;
		}
		if ((rcb3_bstate & RCB3_MSG_BUTTON_SQUARE) != 0U) {
			foglamp = TRUE;
		}
		if ((rcb3_bstate & RCB3_MSG_BUTTON_TRIANGLE) != 0U) {
			hazard = TRUE;
		}
		if ((rcb3_bstate & RCB3_MSG_BUTTON_R1) != 0U) {
			winker_r = TRUE;
		}
		if ((rcb3_bstate & RCB3_MSG_BUTTON_L1) != 0U) {
			winker_l = TRUE;
		}

		/* ƥ(-6364Ĵ) */
		angle = (-1) * ((IDT_Angle) ((rcb3_bstate >> 16U) & 0xFFU) - 64);

		/* ʡ(-6364Ĵ) */
		speed = (-1) * ((IDT_Speed) ((rcb3_bstate >> 24U) & 0xFFU) - 64);

		/* ƥĴ */
		if ((rcb3_bstate & RCB3_MSG_BUTTON_UP) != 0U) {
			steern = CONTCMD_STEERN_I; /* ƥ󥰥˥塼ȥͤ */
		}
		else if ((rcb3_bstate & RCB3_MSG_BUTTON_RIGHT) != 0U) {
			steern = CONTCMD_STEERN_R; /* ƥ󥰤Υ˥塼ȥ򱦤Ĵ */
		}
		else if ((rcb3_bstate & RCB3_MSG_BUTTON_LEFT) != 0U) {
			steern = CONTCMD_STEERN_L; /* ƥ󥰤Υ˥塼ȥ򺸤Ĵ */
		}
		else {
			steern = 0U; /* ׵ʤ */
		}

		/* Ĵ */
		if ((rcb3_bstate & RCB3_MSG_BUTTON_DOWN) != 0U) {
			gain = CONTCMD_GAIN_I;  /* ⡼ͤˤ */
		}
		else if ((rcb3_bstate & RCB3_MSG_BUTTON_R2) != 0U) {
			gain = CONTCMD_GAIN_U;  /* ⡼1ʳ夲 */
		}
		else if ((rcb3_bstate & RCB3_MSG_BUTTON_L2) != 0U) {
			gain = CONTCMD_GAIN_D;  /* ⡼1ʳ */
		}
		else {
			gain = 0U;  /* ׵ʤ */
		}

		/* ֥졼 */
		if ((rcb3_bstate & RCB3_MSG_BUTTON_CROSS) != 0U) {
			brake = TRUE;
		}

		/* IfDriving */
		Rte_Write_DrivingOut_angle(angle);
		Rte_Write_DrivingOut_speed(speed);
		Rte_Write_DrivingOut_steern(steern);
		Rte_Write_DrivingOut_gain(gain);
		Rte_Write_DrivingOut_brake(brake);

		/* IfBodyؤ */
		Rte_Write_BodyOut_headlamp(headlamp);
		Rte_Write_BodyOut_foglamp(foglamp);
		Rte_Write_BodyOut_hazard(hazard);
		Rte_Write_BodyOut_winker_r(winker_r);
		Rte_Write_BodyOut_winker_l(winker_l);
	}


#ifdef TOPPERS_WITH_DISP
	/* ɽ׵ */
	ercd = Rte_Call_DisplayCommandClt_OpGetDisplayCommand(&disp);
	if (ercd != RTE_E_OK) {
		syslog(LOG_INFO, "## Error: Rte_Call_DisplayCommandClt_OpGetDisplayCommand()");
	}
	else if (disp != NOT_RECEIVE_COMMAND) {
		/* ɽ */
		cycle = disp & 0xFFFFU;

		/* ʬΤɽ뤫ɤ */
		if ((disp & 0x00010000U) != 0U) {
			differ = TRUE;
		}

		/* ON/OFFڤؤ */
		if ((disp & 0x00020000U) != 0U) {
			swich_angle = TRUE;
		}
		if ((disp & 0x00040000U) != 0U) {
			swich_speed = TRUE;
		}
		if ((disp & 0x00080000U) != 0U) {
			pwm_angle = TRUE;
		}
		if ((disp & 0x00100000U) != 0U) {
			pwm_speed = TRUE;
		}

		/* IfDisplayMode */
		Rte_Write_DisplayModeOut_cycle(cycle);
		Rte_Write_DisplayModeOut_differ(differ);
		Rte_Write_DisplayModeOut_angle(swich_angle);
		Rte_Write_DisplayModeOut_speed(swich_speed);
		Rte_Write_DisplayModeOut_pwm_angle(pwm_angle);
		Rte_Write_DisplayModeOut_pwm_speed(pwm_speed);
	}
#endif /* TOPPERS_WITH_DISP */
}
